<template>
  <div class="pbbasic">
    <el-form
      :inline="true"
      :model="dataForm"
      @keyup.enter.native="getDataList()">
      <el-form-item>
        <el-input
          v-model="dataForm.key"
          placeholder="关键字"
          clearable>
        </el-input>
      </el-form-item>
      <el-form-item>
        <el-button @click="getDataList()">查询</el-button>
      </el-form-item>
      <el-form-item>
        <el-button v-if="isAuth('sys:role:save')" type="primary" @click="addOrUpdateHandle()">新增</el-button>
      </el-form-item>
      <el-form-item>
        <el-button v-if="isAuth('sys:role:delete')" type="danger" @click="deleteHandle()" :disabled="selectionDataList.length <= 0">批量删除</el-button>
      </el-form-item>
    </el-form>
    <el-table
      :data="dataList"
      @selection-change="selectionChangeHandle"
      v-loading="dataListLoading"
      style="width: 100%">
      <el-table-column
        type="selection"
        header-align="center"
        align="center"
        width="50">
      </el-table-column>
      <el-table-column type="expand">
        <template slot-scope="props">
          <el-form label-position="left" inline class="demo-table-expand">
            <el-form-item label="耳标">
              <span>{{ props.row.eartag }}</span>
            </el-form-item>
            <el-form-item label="年龄">
              <span>{{ props.row.dayAge }}天</span>
            </el-form-item>
            <el-form-item label="健康状况">
              <span>{{ props.row.healthStatus? '健康': '不健康' }}</span>
            </el-form-item>
            <el-form-item label="体重">
              <span>{{ props.row.weight }}千克</span>
            </el-form-item>
            <el-form-item label="品种">
              <span>{{ props.row.breed }}</span>
            </el-form-item>
            <el-form-item label="去向">
              <span>{{ props.row.whereDidYouGo }}</span>
            </el-form-item>
            <el-form-item label="所属单元">
              <span>{{ props.row.unitNumber }}</span>
            </el-form-item>
            <el-form-item label="所属猪舍">
              <span>{{ props.row.phNumber }}</span>
            </el-form-item>
            <el-form-item label="所属牧场">
              <span>{{ props.row.name }}</span>
            </el-form-item>
          </el-form>
        </template>
      </el-table-column>
      <el-table-column
        prop="eartag"
        header-align="center"
        align="center"
        label="年猪耳标">
      </el-table-column>
      <el-table-column
        prop="periodNumber"
        header-align="center"
        align="center"
        label="所属栏期">
      </el-table-column>
      <el-table-column
        prop="unitNumber"
        header-align="center"
        align="center"
        label="所属单元">
      </el-table-column>
      <el-table-column
        prop="phNumber"
        header-align="center"
        align="center"
        label="所属猪舍">
      </el-table-column>
      <el-table-column
        prop="name"
        header-align="center"
        align="center"
        label="所属牧场">
      </el-table-column>
      <el-table-column
        fixed="right"
        header-align="center"
        align="center"
        label="操作">
        <template slot-scope="scope">
          <el-button v-if="isAuth('sys:user:update')" type="text" size="small" @click="addOrUpdateHandle(scope.row)">修改</el-button>
          <el-button v-if="isAuth('sys:user:delete')" type="text" size="small" @click="deleteHandle(scope.row.id)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-dialog
      :title="!form.id ? '新增' : '修改'"
      :close-on-click-modal="false"
      :visible.sync="visible"
      @close="cancel">
      <el-form :model="form" ref="form" @keyup.enter.native="formSubmit()" label-width="80px">
        <el-form-item label="所属牧场">
          <el-select v-model="form.pastureId" placeholder="请选择所属牧场" @change="getPasture" ref="pasture">
            <el-option
              v-for="item in pastureList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="所属猪舍">
          <el-select v-model="form.pigstyId" placeholder="请选择所属猪舍" @change="getPigsty">
            <el-option
              v-for="item in phSelectedList"
              :key="item.id"
              :label="item.number"
              :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="单元编号">
          <el-select v-model="form.unitId" placeholder="请选择所属单元" @change="getUnit">
            <el-option
              v-for="item in unSelectedList"
              :key="item.id"
              :label="item.number"
              :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="栏期编号">
          <el-select v-model="form.periodId" placeholder="请选择所属栏期" @change="getPeriod">
            <el-option
              v-for="item in peSelectedList"
              :key="item.id"
              :label="item.number"
              :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="耳标">
          <el-input v-model="form.eartag" placeholder="请输入耳标"></el-input>
        </el-form-item>
        <el-form-item label="性别">
          <el-select v-model="form.sex" placeholder="请选择性别">
            <el-option
              v-for="item in sex"
              :key="item.label"
              :label="item.label"
              :value="item.value">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="出生日期">
          <el-date-picker
            v-model="form.birthday"
            type="date" 
            value-format="yyyy-MM-dd" 
            placeholder="请选择出生日期"
            @change="changeBirth">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="年龄">
          <!-- <el-input v-model="form.dayAge" placeholder="请输入年龄（天）"></el-input> -->
          <el-input-number v-model="form.dayAge" :step="1" :max="10000000000" :min="0" @change="changeDay"></el-input-number> 天
        </el-form-item>
        <el-form-item label="健康状况">
          <el-select v-model="form.healthStatus" placeholder="请选择健康状况">
            <el-option
              v-for="item in health"
              :key="item.label"
              :label="item.label"
              :value="item.value">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="体重">
          <el-input-number v-model="form.weight" :step="0.01" :max="1000000" :min="0"></el-input-number> 千克
          <!-- <el-input v-model="form.weight" placeholder="请输入体重（千克）"></el-input> -->
        </el-form-item>
        <el-form-item label="品种">
          <el-input v-model="form.breed" placeholder="请输入品种"></el-input>
        </el-form-item>
        <el-form-item label="去向">
          <el-input v-model="form.whereDidYouGo" placeholder="请输入去向"></el-input>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="cancel">取消</el-button>
        <el-button type="primary" @click="formSubmit()">确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
export default {
  data () {
    return {
      dataForm: {
        key: ''
      },
      dataList: [],
      pageIndex: 1,
      pageSize: 10,
      totalPage: 0,
      dataListLoading: false,
      selectionDataList: [],
      visible: false,
      form: {
        id: '',
        unitId: '',
        weight: '',
        whereDidYouGo: '',
        dayAge: '',
        eartag: '',
        healthStatus: '',
        breed: '',
        birthday: '',
        sex: '',
        pigstyId: '',
        periodId: '',
        pastureId: ''
      },
      pastureList: [], // 牧场list
      pighouseList: [], // 猪舍list
      phSelectedList: [], // 选择过牧场后的猪舍list
      unitList: [], // 单元list
      unSelectedList: [], // 选择过后的单元list
      periodList: [], // 栏期list
      peSelectedList: [], // 选择过后的栏期list
      health: [
        {
          value: true,
          label: '健康'
        },
        {
          value: false,
          label: '不健康'
        }
      ],
      sex: [
        {
          value: '公',
          label: '公'
        },
        {
          value: '母',
          label: '母'
        }
      ]
    }
  },
  mounted () {
    this.getDataList()
  },
  methods: {
    // 获取数据列表
    getDataList () {
      this.dataListLoading = true
      this.$http({
        url: this.$http.adornUrl('/management/yearpigbase/list'),
        method: 'post',
        params: this.$http.adornParams({
          page: 1,
          limit: 10,
          keywords: this.dataForm.key
        })
      }).then(async ({ data }) => {
        // 获取所有牧场
        let pastureResult = await this.$http({
          url: this.$http.adornUrl('/management/pasture/findAll'),
          method: 'post'
        })
        pastureResult.data.all && (this.pastureList = pastureResult.data.all)
        // 获取所有猪舍
        let pighouseResult = await this.$http({
          url: this.$http.adornUrl('/management/pigsty/findAll'),
          method: 'post'
        })
        pighouseResult.data.all && (this.pighouseList = pighouseResult.data.all)
        // 获取所有单元
        let unitResult = await this.$http({
          url: this.$http.adornUrl('/management/unit/findAll'),
          method: 'post'
        })
        unitResult.data.all && (this.unitList = unitResult.data.all)
        // 获取所有栏期
        let periodResult = await this.$http({
          url: this.$http.adornUrl('/management/period/findAll'),
          method: 'post'
        })
        periodResult.data.all && (this.periodList = periodResult.data.all)
        if (data && data.code === 0) {
          this.dataList = data.page.list
          this.totalPage = data.page.totalCount
          // 单元对应
          this.dataList.forEach(item => {
            for (let unit of this.unitList) {
              if (item.unitId === unit.id) {
                item.unitNumber = unit.number
                item.pastureId = unit.pastureId
                item.pigstyId = unit.pigstyId
                break
              }
            }
          })
          // 牧场对应
          this.dataList.forEach(item => {
            for (let pasture of this.pastureList) {
              if (item.pastureId === pasture.id) {
                item.name = pasture.name
                break
              }
            }
          })
          // 猪舍对应
          this.dataList.forEach(item => {
            for (let pighouse of this.pighouseList) {
              if (item.pigstyId === pighouse.id) {
                item.phNumber = pighouse.number
                break
              }
            }
          })
          // 栏期对应
          this.dataList.forEach(item => {
            for (let period of this.periodList) {
              if (item.periodId === period.id) {
                item.periodNumber = period.number
                break
              }
            }
          })
          // 初始化时，选择后的与未选择的list相同
          this.phSelectedList = this.pighouseList
          this.unSelectedList = this.unitList
          this.peSelectedList = this.periodList
        } else {
          this.dataList = []
          this.totalPage = 0
        }
        this.dataListLoading = false
      })
    },
    // 每页数
    sizeChangeHandle (val) {
      this.pageSize = val
      this.pageIndex = 1
      this.getDataList()
    },
    // 当前页
    currentChangeHandle (val) {
      this.pageIndex = val
      this.getDataList()
    },
    // 获取出生日期
    changeBirth (val) {
      let birth = new Date(val)
      let now = new Date()
      let days = now.getTime() - birth.getTime()
      if (days < 0) {
        this.$confirm(`出生日期有误`, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          console.log('还没出生呢...');
        }).catch(() => {})
      }
      this.form.dayAge = parseInt(days / (1000 * 60 * 60 * 24))
    },
    // 获取dayAge
    changeDay (val) {
      let now = new Date()
      let birth = new Date(now.setDate(now.getDate() - val))
      let month = birth.getMonth() < 9? '0' + (birth.getMonth() + 1): (birth.getMonth() + 1)
      let date = birth.getDate() < 10? '0' + birth.getDate(): birth.getDate()
      this.form.birthday = `${birth.getFullYear()}-${month}-${date}`
    },
    // 获取到了牧场 → 猪舍 + 单元 + 栏期处理
    getPasture (val) {
      /** 关于猪舍 */
      //  → 限制猪舍
      this.phSelectedList = []
      this.pighouseList.forEach(item => {
        if (item.pastureId === val) {
          this.phSelectedList.push(item)
        }
      })
      // 判断当前 猪舍 是否需要清除
      let pigsty = this.pigstyByYid(this.form.pigstyId)
      if (pigsty && pigsty.pastureId !== val) {
        this.form.pigstyId = ''
      }
      /** 关于单元 */
      //  → 限制单元
      this.unSelectedList = []
      this.unitList.forEach(item => {
        if (item.pastureId === val) {
          this.unSelectedList.push(item)
        }
      });
      // 判断当前 单元 是否需要清除
      let unit = this.UnitByIid(this.form.unitId)
      if (unit && unit.pastureId !== val) {
        this.form.unitId = ''
      }
      /** 关于栏期 */
      //  → 限制栏期
      this.peSelectedList = []
      this.periodList.forEach(item => {
        if (item.pastureId === val) {
          this.peSelectedList.push(item)
        }
      });
      // 判断当前 栏期 是否需要清除
      let period = this.periodByJid(this.form.periodId)
      if (period && period.pastureId !== val) {
        this.form.periodId = ''
      }
    },
    // 获取到猪舍 → 牧场 + 猪舍自身 + 单元 + 栏期处理
    getPigsty (val) {
      //  → 反向确定牧场
      let pigsty = this.pigstyByYid(this.form.pigstyId)
      this.form.pastureId = pigsty.pastureId
      // → 先获取猪舍，没有确定牧场的情况下，限制猪舍自身
      this.phSelectedList = this.xidYlist(pigsty.pastureId)
      /** 关于单元 */
      // → 限制单元
      this.unSelectedList = []
      this.unitList.forEach(item => {
        if (item.pigstyId === val) {
          this.unSelectedList.push(item)
        }
      });
      // 判断当前 单元 是否需要清除
      let unit = this.UnitByIid(this.form.unitId)
      if (unit && unit.pigstyId !== val) {
        this.form.unitId = ''
      }
      /** 关于栏期 */
      // → 限制栏期
      this.peSelectedList = []
      this.periodList.forEach(item => {
        if (item.pigstyId === val) {
          this.peSelectedList.push(item)
        }
      });
      // 判断当前 栏期 是否需要清除
      let period = this.periodByJid(this.form.periodId)
      if (period && period.pigstyId !== val) {
        this.form.periodId = ''
      }
    },
    // 获取到了单元 → 牧场 + 猪舍 + 单元自身处理
    getUnit (val) {
      let unit = this.UnitByIid(val)
      // 反向确定 牧场 + 猪舍
      this.form.pastureId = unit.pastureId
      this.form.pigstyId = unit.pigstyId
      // 反向确定 猪舍selectedList + 单元selectedList + 栏期selectedList
      this.phSelectedList = this.xidYlist(unit.pastureId)
      this.unSelectedList = this.yidIlist (unit.pigstyId)
      this.peSelectedList = this.yidJlist (unit.pigstyId)
      // 判断当前栏期是否需要清除
      let period = this.periodByJid(this.form.periodId)
      if (period && period.pigstyId !== unit.pigstyId) {
        this.form.periodId = ''
      }
    },
    // 根据牧场id → 限制猪舍selectedList
    xidYlist (pastureId) {
      let phSelectedList = []
      this.pighouseList.forEach(item => {
        if (item.pastureId === pastureId) {
          phSelectedList.push(item)
        }
      })
      return phSelectedList
    },
    // 根据猪舍id → 限制栏期selectedList
    yidJlist (pigstyId) {
      let peSelectedList = []
      this.periodList.forEach(item => {
        if (item.pigstyId === pigstyId) {
          peSelectedList.push(item)
        }
      })
      return peSelectedList
    },
    // 根据猪舍id → 限制单元selectedList
    yidIlist (pigstyId) {
      let unSelectedList = []
      this.unitList.forEach(item => {
        if (item.pigstyId === pigstyId) {
          unSelectedList.push(item)
        }
      })
      return unSelectedList
    },
    // 根据猪舍id → 返回猪舍信息
    pigstyByYid (pigstyId) {
      for (let item of this.pighouseList) {
        if (item.id === pigstyId) {
          return item
        }
      }
      return null
    },
    // 根据栏期id → 返回栏期信息
    periodByJid (periodId) {
      for (let item of this.periodList) {
        if (item.id === periodId) {
          return item
        }
      }
      return null
    },
    // 根据单元id → 返回单元信息
    UnitByIid (unitId) {
      for (let item of this.unitList) {
        if (item.id === unitId) {
          return item
        }
      }
      return null
    },
    // 获取到栏期 → 牧场 + 猪舍 + 单元自身处理
    getPeriod (val) {
      let period = this.periodByJid(val)
      // 反向确定牧场 + 猪舍
      this.form.pastureId = period.pastureId
      this.form.pigstyId = period.pigstyId
      // 反向确定 猪舍selectedList + 单元selectedList + 栏期selectedList
      this.phSelectedList = this.xidYlist(period.pastureId)
      this.unSelectedList = this.yidIlist (period.pigstyId)
      this.peSelectedList = this.yidJlist (period.pigstyId)
      // 判断当前 单元 是否需要清除
      let unit = this.UnitByIid(this.form.unitId)
      if (unit && unit.pigstyId !== period.pigstyId) {
        this.form.unitId = ''
      }
    },
    // 新增 or 修改单元
    addOrUpdateHandle (row) {
      // 显示牧场新增 or 修改面板
      this.visible = true
      if (row) {
        this.form = row
      }
    },
    // 选择n个牧场
    selectionChangeHandle (val) {
      this.selectionDataList = []
      val.forEach(item => {
        this.selectionDataList.push(item.id)
      });
    },
    // 删除n个牧场
    deleteHandle (id) {
      this.$confirm(`确定删除年猪？`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        // 删除操作
        if (id) {
          this.selectionDataList.push(id)
        }
        if (this.selectionDataList.length <= 0) {
          return
        }
        this.$http({
          url: this.$http.adornUrl('/management/yearpigbase/delete'),
          method: 'post',
          data: this.$http.adornData(this.selectionDataList, false)
        }).then(result => {
          if (result.data.code === 0) {
            this.getDataList()
            this.resetForm()
            this.$message({
              message: '成功删除年猪',
              type: 'success',
              duration: 1000
            })
            // pageIndex修正
            this.totalPage -= this.selectionDataList.length
            let pages = Math.ceil(this.totalPage / this.pageSize)
            this.pageIndex = this.pageIndex > pages? pages: this.pageIndex
            this.pageIndex = this.pageIndex < 1? pages: this.pageIndex
          } else {
            this.$message.error('删除年猪失败');
          }
          this.selectionDataList = []
        })
      }).catch(() => {})
    },
    formSubmit () {
      if (this.form.id) {
        // 修改
        // 输入是否完整
        if (!this.confirmComplete()) {
          return
        }
        // 输入是否合法
        if (!this.confirmInput()) {
          return
        }
        // 进行修改操作
        this.$http({
          url: this.$http.adornUrl('/management/yearpigbase/update'),
          method: 'post',
          data: this.$http.adornData({
            id: this.form.id,
            unitId: this.form.unitId,
            dayAge: parseInt(this.form.dayAge),
            eartag: this.form.eartag,
            healthStatus: this.form.healthStatus,
            weight: parseFloat(this.form.weight),
            whereDidYouGo: this.form.whereDidYouGo,
            breed: this.form.breed,
            pigstyId: this.form.phNumber,
            birthday: this.form.birthday,
            sex: this.form.sex,
            periodId: this.form.periodId,
            pigstyId: this.form.pigstyId
          })
        }).then(result => {
          if (result.data.code === 0) {
            this.resetForm();
            console.log(result);
            console.log(this.form);
            this.visible = false;
            this.$message({
              message: '成功修改年猪信息',
              type: 'success',
              duration: 1000
            })
          } else {
            // TODO: 年猪耳标重复
            if (result.data.code === 600) {
              // this.$message.error('牧场名称 ' + result.data.msg)
              // let msg = result.data.msg.split(' ')
              // this.$message({
              //   message: `牧场名称 <p style="color:#333; display:inline">${msg[0]}</p> 已经存在！`,
              //   type: "error",
              //   duration: 1000,
              //   dangerouslyUseHTMLString: true
              // })
              this.$message.error(result.data.msg);
              return
            }
            this.$message.error('修改年猪信息失败');
          }
        })
      } else {
        // 新增
        // 输入是否完整
        if (!this.confirmComplete(1)) {
          return
        }
        // 输入是否合法
        if (!this.confirmInput()) {
          return
        }
        // 进行新增操作
        console.log('进行新增操作');
        this.$http({
          url: this.$http.adornUrl('/management/yearpigbase/save'),
          method: 'post',
          data: this.$http.adornData({
            unitId: this.form.unitId,
            dayAge: parseInt(this.form.dayAge),
            eartag: this.form.eartag,
            healthStatus: this.form.healthStatus,
            weight: parseInt(this.form.weight),
            whereDidYouGo: this.form.whereDidYouGo,
            breed: this.form.breed,
            pigstyId: this.form.phNumber,
            birthday: this.form.birthday,
            sex: this.form.sex,
            periodId: this.form.periodId,
            pigstyId: this.form.pigstyId
          })
        }).then(result => {
          if (result.data.code === 0) {
            // 新增pageIndex的修正
            this.totalPage++
            let pages = Math.ceil(this.totalPage / this.pageSize)
            this.pageIndex = this.pageIndex < pages? pages: this.pageIndex
            this.resetForm()
            this.visible = false;
            this.$message({
              message: '成功添加年猪',
              type: 'success',
              duration: 1000
            })
          } else {
            // TODO: 年猪耳标重复
            if (result.data.code === 600) {
              // this.$message.error('牧场名称 ' + result.data.msg)
              // let msg = result.data.msg.split(' ')
              // this.$message({
              //   message: `牧场名称 <p style="color:#333; display:inline">${msg[0]}</p> 已经存在！`,
              //   type: "error",
              //   duration: 1000,
              //   dangerouslyUseHTMLString: true
              // })
              this.$message.error(result.data.msg);
              return
            }
            this.$message.error('添加年猪失败');
          }
        })
      }
    },
    // 校验输入是否完整
    validComplete (val) {
      val && (delete this.form.id, delete this.form.deleted, delete this.form.fosterStatus, delete this.form.gmtCreate, delete this.form.gmtModified, delete this.form.periodNumber, delete this.form.phNumber, delete this.form.unitNumber, delete this.form.name)
      for (let i in this.form) {
        if (!this.form[i].toString()) {
          return false
        }
      }
      return true
    },
    // 如不完整，则提示
    confirmComplete (val) {
      if (this.validComplete(val)) {
        return true
      }
      this.$confirm(`请输入完整`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        console.log('输入不完整');
      }).catch(() => {})
      return false
    },
    // 校验输入是否合法
    validInput () {
      // 出生日期是否有误
      let birth = new Date(this.form.birthday)
      let now = new Date()
      let days = now.getTime() - birth.getTime()
      if (days < 0) {
        return false
      }
      if (this.form.weight <= 0) {
        return false
      }
      // 只允许中文、英文、数字、-、_的输入，取反
      const reg = /[^\a-\z\A-\Z0-9\u4E00-\u9FA5\_\-]/g
      if (reg.test(this.form.eartag)) {
        return false
      }
      if (reg.test(this.form.breed)) {
        return false
      }
      if (reg.test(this.form.whereDidYouGo)) {
        return false
      }
      return true
    },
    // 如不合法，则提示
    confirmInput () {
      if (this.validInput()) {
        return true
      }
      this.$confirm(`请检查输入项是否合法`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        console.log('输入不合法');
      }).catch(() => {})
      return false
    },
    // 清空form
    resetForm () {
      for (let i in this.form) {
        this.form[i] = ''
      }
      this.getDataList()
    },
    // 取消
    cancel () {
      this.visible = false
      this.resetForm()
    }
  }
}
</script>
<style>
.demo-table-expand {
  font-size: 0;
  margin-left: 40px;
}
.demo-table-expand label {
  width: 90px;
  color: #99a9bf;
}
.demo-table-expand .el-form-item {
  margin-right: 0;
  margin-bottom: 0;
  width: 80%;
}
</style>